
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

#define LEN	1023

typedef struct List {
		char		*path;
		double		base,step;
		int		Dx,Dy;
		struct List	*next;
	} List;

typedef struct {
		int	i;
		double	d;
	} Sum;

#define ALLOC(type,size)	(type *)malloc((size_t)(size)*sizeof(type))

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	ac,Dx,Dy,len,Nx,Ny,x1,y1,x2,y2,X1,Y1,X2,Y2,BPS,y,x,images=0;
	char	**av,path[LEN],*mae="memory allocation error.";
	List	*list,*top=NULL,**ptr=(&top);
	double	base,step,roof,none,val,min,max;
	Sum	**sum,**sy,*sx;
	Cell	**out,**in;

	for (ac=argc; ac>4 && ac!=6 && ac!=8 && ac!=10; ac-=5) ++images;

	if (ac<4)
	    Error("usage : add_2d {(TIFF[1] base[1] step[1] Dx[1] Dy[1]) ...\n"
		  "                (TIFF[N] base[N] step[N] Dx[N] Dy[N])}\n"
		  "               none {base step} BPS {x1 y1 x2 y2} TIFF");

	if (images)
	    for (av=argv; --images>=0; av+=5) {
		if ((*ptr=list=ALLOC(List,1))==NULL) Error(mae);

		list->path=av[1];
		list->base=atof(av[2]);
		list->step=atof(av[3]);
		list->Dx=atoi(av[4]);
		list->Dy=atoi(av[5]);
		*(ptr=(&(list->next)))=NULL;
	    }
	else {
	    while (scanf("%s %lf %lf %d %d",path,&base,&step,&Dx,&Dy)==5) {
		for (len=0; path[len]!='\0'; len++) ;

		if ((*ptr=list=ALLOC(List,1))==NULL ||
		    (list->path=ALLOC(char,len+1))==NULL) Error(mae);

		do list->path[len]=path[len]; while (--len>=0);

		list->base=base;
		list->step=step;
		list->Dx=Dx;
		list->Dy=Dy;
		*(ptr=(&(list->next)))=NULL;
	    }
	    if (top==NULL) Error("no image.");
	}
	for (list=top; list!=NULL; list=list->next) {
	    ReadImageFile(list->path,&Nx,&Ny,NULL,NULL,NULL);

	    x2=(x1=list->Dx)+Nx-1;
	    y2=(y1=list->Dy)+Ny-1;
	    if (list==top) {
		X1=x1; X2=x2;
		Y1=y1; Y2=y2;
	    }
	    else {
		if (x1<X1) X1=x1; if (x2>X2) X2=x2;
		if (y1<Y1) Y1=y1; if (y2>Y2) Y2=y2;
	    }
	}
	if (ac==8 || ac==10) {
	    if ((x1=atoi(argv[argc-5]))>
		(x2=atoi(argv[argc-3])) || x1>X2 || x2<X1 ||
		(y1=atoi(argv[argc-4]))>
		(y2=atoi(argv[argc-2])) || y1>Y2 || y2<Y1) Error("bad area.");

	    X1=x1; Y1=y1; X2=x2; Y2=y2;
	}
	if ((BPS=atoi(argv[argc-((ac==4 || ac==6)?2:6)]))<1 ||
	    BPS>8*sizeof(Cell)) Error("bad BPS.");

	if (ac==6 || ac==10) {
	    if ((step=atof(argv[argc-((ac==6)?3:7)]))<=0.0) Error("bad step.");

	    base=atof(argv[argc-((ac==6)?4:8)]);
	    roof=base+step*(double)((1<<BPS)-1);
	}
	none=atof(argv[argc-ac+1]);

	X2-=(X1-1);
	Y2-=(Y1-1);

	if ((out=(Cell **)(sum=sy=ALLOC(Sum *,Y2)))==NULL) Error(mae);

	for (y=0; y<Y2; y++, sy++) {
	    if ((*sy=sx=ALLOC(Sum,X2))==NULL) Error(mae);

	    for (x=0; x<X2; x++, sx++) sx->d=(double)(sx->i=0);
	}
	for (list=top; list!=NULL; list=list->next) {
	    ReadImageFile(list->path,&Nx,&Ny,NULL,&in,NULL);

	    Dx=list->Dx-X1; x1=(Dx>=0)?0:-Dx; if ((x2=X2-Dx)>Nx) x2=Nx;
	    Dy=list->Dy-Y1; y1=(Dy>=0)?0:-Dy; if ((y2=Y2-Dy)>Ny) y2=Ny;
	    for (sy=sum  +Dy+(y=y1); y<y2; y++, sy++)
	    for (sx=(*sy)+Dx+(x=x1); x<x2; x++, sx++)
#ifdef	NZ
	    if (in[y][x])
#endif
	    {
		++sx->i; sx->d+=(list->base+list->step*(double)in[y][x]);
	    }
	    for (y=Ny-1; y>=0; y--) free(in[y]);
	}
	for (sy=sum,   y=0; y<Y2; y++, sy++)
	for (sx=(*sy), x=0; x<X2; x++, sx++) {
	    val=(sx->i)?sx->d/(double)sx->i:none;

	    if (x==0 && y==0)
		min=max=val;
	    else
		if (val<min) min=val; else if (val>max) max=val;
	}
	if (ac==4 || ac==8) {
	    if (min==max) fputs("no value range (warning).\n",stderr);

	    step=(max-min)/(double)((1<<BPS)-1); base=min; roof=max;
	}
	printf("%lf\t%lf\t%lf\t%18.16lf\n",min,max,base,step);

	for (sy=sum,   y=0; y<Y2; y++, sy++)
	for (sx=(*sy), x=0; x<X2; x++, sx++) {
	    val=(sx->i)?sx->d/(double)sx->i:none;

	    out[y][x]=(val<=base)?0:
		      (val>=roof)?(Cell)((1<<BPS)-1):
				  (Cell)((val-base)/step+0.5);
	}
	StoreImageFile(argv[argc-1],X2,Y2,BPS,out,NULL);

	return 0;
}
