
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

#ifndef	CSI_BS
#define	CSI_BS
#endif

#include "csi.h"

extern void	Error();

#define LEN	1023

static int	Scan(dir,NBS,Dx,Dy,Dz)
char		*dir,*NBS;
int		*Dx,*Dy,*Dz;
{
	int	c,start=1,quote=0,len=0;

	if (scanf("%s",dir)!=1) return 0;

	for (;;) {
	    if ((c=getchar())==EOF) return 0;

	    if (start) {
		if (c==' ' || c=='\t' || c=='\n') continue;

		start=0;
	    }
	    if (quote==0) {
		if (c==' ' || c=='\t' || c=='\n') break;

		if (c=='"' || c=='\'') {
		    quote=c; continue;
		}
	    }
	    else
		if (c==quote) {
		    quote=0; continue;
		}

	    NBS[len]=c; if (++len==LEN) return 0;
	}
	NBS[len]='\0';

	return scanf("%d %d %d",Dx,Dy,Dz)==3;
}

typedef struct List {
		PBS		*pbs;
		int		Nx,Ny,Nz,Dx,Dy,Dz;
		struct List	*next;
	} List;

typedef struct {
		int	i;
		double	d;
	} Sum;

#define ALLOC(type,size)	(type *)malloc((size_t)(size)*sizeof(type))

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	ac,Dx,Dy,Dz,x1,y1,z1,x2,y2,z2,X1,Y1,Z1,X2,Y2,Z2,
		BPS,y,len,z,x,Nx,Ny,images=0;
	char	**av,dir[LEN],NBS[LEN],format[LEN],slice[LEN],path[LEN],
		*mae="memory allocation error.";
	List	*list,*top=NULL,**ptr=(&top);
	double	base,step,roof,none,val,min,max;
	Sum	**sum,**sy,*sx;
	Cell	**out,**in;
	PBS	*pbs;

	for (ac=argc; ac>4 && ac!=6 && ac!=10 && ac!=12; ac-=5) ++images;

	if (ac<4)
	Error("usage : add_3d {(dir[1] NBS[1] Dx[1] Dy[1] Dz[1]) ...\n"
	      "                (dir[N] NBS[N] Dx[N] Dy[N] Dz[N])}\n"
	      "               none {base step} BPS {x1 y1 z1 x2 y2 z2} dir");

	if (images)
	    for (av=argv; --images>=0; av+=5) {
		if ((*ptr=list=ALLOC(List,1))==NULL) Error(mae);

		list->pbs=CheckSliceImages(av[1],av[2],&(list->Nx),
						       &(list->Ny),
						       &(list->Nz),NULL);
		list->Dx=atoi(av[3]);
		list->Dy=atoi(av[4]);
		list->Dz=atoi(av[5]);
		*(ptr=(&(list->next)))=NULL;
	    }
	else {
	    while (Scan(dir,NBS,&Dx,&Dy,&Dz)) {
		if ((*ptr=list=ALLOC(List,1))==NULL) Error(mae);

		list->pbs=CheckSliceImages(dir,NBS,&(list->Nx),
						   &(list->Ny),
						   &(list->Nz),NULL);
		list->Dx=Dx;
		list->Dy=Dy;
		list->Dz=Dz;
		*(ptr=(&(list->next)))=NULL;
	    }
	    if (top==NULL) Error("no image.");
	}
	for (list=top; list!=NULL; list=list->next) {
	    x2=(x1=list->Dx)+list->Nx-1;
	    y2=(y1=list->Dy)+list->Ny-1;
	    z2=(z1=list->Dz)+list->Nz-1;
	    if (list==top) {
		X1=x1; X2=x2;
		Y1=y1; Y2=y2;
		Z1=z1; Z2=z2;
	    }
	    else {
		if (x1<X1) X1=x1; if (x2>X2) X2=x2;
		if (y1<Y1) Y1=y1; if (y2>Y2) Y2=y2;
		if (z1<Z1) Z1=z1; if (z2>Z2) Z2=z2;
	    }
	}
	if (ac==10 || ac==12) {
	    if ((x1=atoi(argv[argc-7]))>
		(x2=atoi(argv[argc-4])) || x1>X2 || x2<X1 ||
		(y1=atoi(argv[argc-6]))>
		(y2=atoi(argv[argc-3])) || y1>Y2 || y2<Y1 ||
		(z1=atoi(argv[argc-5]))>
		(z2=atoi(argv[argc-2])) || z1>Z2 || z2<Z1) Error("bad area.");

	    X1=x1; Y1=y1; Z1=z1; X2=x2; Y2=y2; Z2=z2;
	}
	if ((BPS=atoi(argv[argc-((ac==4 || ac==6)?2:8)]))<1 ||
	    BPS>8*sizeof(Cell)) Error("bad BPS.");

	if (ac==6 || ac==12) {
	    if ((step=atof(argv[argc-((ac==6)?3:9)]))<=0.0) Error("bad step.");

	    base=atof(argv[argc-((ac==6)?4:10)]);
	    roof=base+step*(double)((1<<BPS)-1);
	}
	none=atof(argv[argc-ac+1]);

	X2-=(X1-1);
	Y2-=(Y1-1);
	Z2-=(Z1-1);

	if ((out=(Cell **)(sum=sy=ALLOC(Sum *,Y2)))==NULL) Error(mae);

	for (y=0; y<Y2; y++, sy++) if ((*sy=ALLOC(Sum,X2))==NULL) Error(mae);

	len=1; for (z=Z2-1; z>=10; z/=10) ++len;
	sprintf(format,"%%0%dd",len);

	for (z=0; z<Z2; z++) {
	    for (sy=sum,   y=0; y<Y2; y++, sy++)
	    for (sx=(*sy), x=0; x<X2; x++, sx++) sx->d=(double)(sx->i=0);

	    for (list=top; list!=NULL; list=list->next)
		if ((Dz=z+Z1-list->Dz)>=0 && Dz<list->Nz) {
		    pbs=list->pbs+Dz;

		    ReadImageFile(pbs->path,&Nx,&Ny,NULL,&in,NULL);

		    Dx=list->Dx-X1; x1=(Dx>=0)?0:-Dx; if ((x2=X2-Dx)>Nx) x2=Nx;
		    Dy=list->Dy-Y1; y1=(Dy>=0)?0:-Dy; if ((y2=Y2-Dy)>Ny) y2=Ny;
		    for (sy=sum  +Dy+(y=y1); y<y2; y++, sy++)
		    for (sx=(*sy)+Dx+(x=x1); x<x2; x++, sx++)
#ifdef	NZ
		    if (in[y][x])
#endif
		    {
			++sx->i; sx->d+=(pbs->base+pbs->step*(double)in[y][x]);
		    }
		    for (y=Ny-1; y>=0; y--) free(in[y]);
		}

	    for (sy=sum,   y=0; y<Y2; y++, sy++)
	    for (sx=(*sy), x=0; x<X2; x++, sx++) {
		val=(sx->i)?sx->d/(double)sx->i:none;

		if (x==0 && y==0)
		    min=max=val;
		else
		    if (val<min) min=val; else if (val>max) max=val;
	    }
	    if (ac==4 || ac==10) {
		if (min==max) fputs("no value range (warning).\n",stderr);

		step=(max-min)/(double)((1<<BPS)-1); base=min; roof=max;
	    }
	    sprintf(slice,format,z);
	    printf("%s\t%lf\t%lf\t%lf\t%18.16lf\n",slice,min,max,base,step);

	    for (sy=sum,   y=0; y<Y2; y++, sy++)
	    for (sx=(*sy), x=0; x<X2; x++, sx++) {
		val=(sx->i)?sx->d/(double)sx->i:none;

		out[y][x]=(val<=base)?0:
			  (val>=roof)?(Cell)((1<<BPS)-1):
				      (Cell)((val-base)/step+0.5);
	    }
	    sprintf(path,"%s/%s.tif",argv[argc-1],slice);
	    StoreImageFile(path,X2,Y2,BPS,out,NULL);
	}
	return 0;
}
