
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

extern void	Error();

static void	Abort(path,msg)
char		*path,*msg;
{
	(void)fprintf(stderr,"%s : ",path); Error(msg);
}

static int	Scan(path,data)
char		*path;
double		**data;
{
	FILE	*file;
	int	N,x;

	if (*path=='-')
	    file=stdin;
	else
	    if ((file=fopen(path,"r"))==NULL) Abort(path,"file not found.");

	if (fscanf(file,"%d",&N)!=1) Abort(path,"bad number of data.");

	if ((*data=(double *)malloc((size_t)N*sizeof(double)))==NULL)
	    Abort(path,"data memory allocation error.");

	for (x=0; x<N; x++)
	    if (fscanf(file,"%lf",*data+x)!=1) Abort(path,"data read error.");

	if (file!=stdin) (void)fclose(file);

	return N;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Ng,Nh,D1,D2,Ngh,d,N,x;
	double	*G,*H,*g,*h,sqrs,diff;

	if (argc!=3 && argc!=5) Error("usage : rmsd_1d data1 data2 {D1 D2}");

	Ng=Scan(argv[1],&G);
	Nh=Scan(argv[2],&H);

	if (argc==3) {
	    D1=1-Nh; D2=Ng-1;
	}
	else
	    if ((D1=atoi(argv[3]))>
		(D2=atoi(argv[4])) || D1<=(-Nh) || D2>=Ng)
		Error("bad range of distance.");

	Ngh=Ng-Nh;

	for (d=D1; d<=D2; d++) {
	    if (d<0) {
		g=G; h=H-d; N=(d>=Ngh)?Ng:Nh+d;
	    }
	    else {
		g=G+d; h=H; N=(d>=Ngh)?Ng-d:Nh;
	    }

	    sqrs=0.0;
	    for (x=0; x<N; x++) {
		diff=(*(g++))-(*(h++)); sqrs+=(diff*diff);
	    }
	    (void)printf("%d\t%lf\n",d,sqrt(sqrs/(double)N));
	}
	return 0;
}
